#include "common.h"

int main(){
    
    resources_init();
    
    resources_create(1, 10);
    resources_create(2, 10);
    resources_create(3, 10);
        
    rv = resources_take(-1, (struct resources_request[]){{1,1}});
    assertVerbose(rv==1, "negative array length");
    
    rv = resources_take(3, (struct resources_request[]){{1,1},{2,1},{1,1}});
    assertVerbose(rv==2, "doubled resource kind");
    
    rv = resources_take(3, (struct resources_request[]){{1,1},{5,1},{2,1}});
    assertVerbose(rv==4, "nonexisting resource kind");
    
    rv = resources_take(3, (struct resources_request[]){{1,1},{2,20},{3,1}});
    assertVerbose(rv==5, "exessive amount");
    
    rv = resources_take(1, (struct resources_request[]){{1,1}});
    assertVerbose(rv==0, "correct take");
    
    rv = resources_take(1, (struct resources_request[]){{2,1}});
    assertVerbose(rv==3, "taking while resources were not returned");
    
    puts("ok");
    return 0;
}
