#include "common.h"

int main(){
    
    resources_init();
    
    resources_create(1, 10);
    resources_create(2, 10);
    resources_create(3, 10);
        
    rv = resources_take(2, (struct resources_request[]){{1,4},{2,4}});
    assert(rv==0);

    rv = resources_return(5, 1);
    assertVerbose(rv==1, "nonexisting resource kind");

    rv = resources_return(3, 1);
    assertVerbose(rv==2, "returning resources that were not taken");

    rv = resources_return(2, 8);
    assertVerbose(rv==3, "returing more than taken");
    
    rv = resources_return(1, 4);
    assert(rv==0);
    
    rv = resources_return(2, 2);
    assert(rv==0);
    
    rv = resources_return(2, 2);
    assert(rv==0);
    
    puts("ok");
    return 0;
}
